function [Uopt,dU,Fc,f1,Aeq,beq,lb,ub,G]=MPCqp(xk,Us,Hu,Hp,Ts,dUp,Q,R,duTdo,hack,currk,current)
global globU globX;
k0=10;
k1=sqrt(4*k0);

%%  Model  %%
M=[25.8 0 0;0 33.8 1.0115;0 1.0115 2.76];
D=[0.9257 0 0;0 2.8909 -0.2601;0 -0.2601 0.5];
Nd=1;
Yd=-0.2;

eps=-(M(3,3)*Yd-M(2,3)*Nd)/(M(2,2)*Nd-M(2,3)*Yd);
Gamma=M(2,2)*M(3,3)-M(2,3)^2;

Theta=(1/Gamma)*(-2*M(2,3)*M(2,2)*eps+M(2,2)^2*eps^2+M(2,3)^2-M(2,2)*M(1,1)*eps^2-M(3,3)*M(1,1)+2*M(2,3)*M(1,1)*eps);
Mm=(1/Gamma)*(M(2,3)*D(3,3)-eps*M(2,2)*D(3,3)-M(3,3)*D(2,3)-M(2,3)*D(3,2)*eps+eps*M(2,3)*D(2,3)+M(2,2)*D(3,2)*eps^2+M(3,3)*D(2,2)*eps-M(2,3)*D(2,2)*eps^2);
Xi=(1/Gamma)*(M(2,2)*M(1,1)*eps-M(2,2)^2*eps-M(2,3)*M(1,1)+M(2,2)*M(2,3));
N=(1/Gamma)*(M(2,3)*D(2,2)*eps-M(2,2)*D(3,2)*eps-M(3,3)*D(2,2)+M(2,3)*D(3,2));
%% end model %%

%%  initial states and paramaters  %%
s=0.05;
u1min=0.5;
uc=0.2;
%% end init %%
ukprev=Us(1:1:3);
Uk=zeros(3*Hu,1);
Uk(1:1:3*Hu-3)=Us(4:1:Hu*3);
Uk(3*Hu-2:1:3*Hu)=Us(Hu*3-2:1:Hu*3);

%dUp(1:1:length(dUp)-5)=dUp(6:1:length(dUp));
%dUp(length(dUp)-2:1:length(dUp))=0;
Ut=zeros(3*Hu,1);
Ut(1:1:3*Hu-3)=Us(4:1:3*Hu);
Ut(3*Hu-2:1:3*Hu)=Us(3*Hu-2:1:3*Hu);
dUp=Ut-Us;

%% run optimization %%
for i=1:1:1,
    [Xpred,Upred] = simXdebug(xk, Uk, Hu, Hp, Ts, s, uc,Theta,N,Mm,Xi,k0,k1,eps,currk,current);
%     [Xpred,Upred] = simXdebug(xk, Uk, Hu, Hp, Ts, s, uc,
%     Theta,N,Mm,Xi,k0,k1,eps);
%     [J,G]=linerizeQp(Upred,Xpred,s,Ts,Hu);
    [J,G]=linerizeNew(Upred,Xpred,s,Ts,Hu);
    
    [S,Setta]=formSetta(Hp,Hu,J,G);
    
    Yfree=nominal2(xk,[ukprev(1); 0; 0],Hp,Ts,s,uc,Theta,Mm,N,Xi,k0,k1,eps,currk,current);
    
    [Fc,f1,Aeq,beq,lb,ub,Ix]=constraints2(Ts,ukprev,u1min,Hu,hack);

    H=Setta'*Q*Setta+R;
    H=(H+H')/2;
    E=-Yfree;
    g=-2*Setta'*Q*E;
    options=optimset('MaxIter',2000,'LargeScale','off');
    dU=quadprog(H,g,Fc,f1,Aeq,beq,lb,ub,dUp,options);
    Uopt=Ix*ukprev+duTdo*dU;

end