clear all;
global xkm Hu Hp Ts s uc Theta N Mm Xi k0 k1 ku eps currk current cost;
step=0.05;
s=step;
stopp=660;
ts=.5;
current=1;
%% current param%%
Vc=0.01;
betac=pi/3;
%% end current%%
cost=3;%must be 0,1,2 or 3. 0, 1 costf2, 2,3 costf3

Hp=48;
Hu=15;
Ts=ts;

ku=5;
uc=0.2;
umin=0.5;
k0=10;
k1=sqrt(4*k0);

wp2=3*[0 0;4 6;9 9;9 16;7 18;4 18;0 16;-1 13;-1 10;1 7;4 7;7 9];%path
endSim2=12;%path
wp=wp2;
endSim=endSim2;
hack=zeros(Hu-1,1);
for i=2:1:Hu-1,
    hack(i)=i*0.0001;
end
%% Model %%
M=[25.8 0 0;0 33.8 1.0115;0 1.0115 2.76];
D=[0.9257 0 0;0 2.8909 -0.2601;0 -0.2601 0.5];
%%% hydrodyn param %%%
Nd=1;
Yd=-0.2;
%%% end hydrodyn %%%
Gamma=M(2,2)*M(3,3)-M(2,3)^2;
eps=-(M(3,3)*Yd-M(2,3)*Nd)/(M(2,2)*Nd-M(2,3)*Yd);
Omega=(1/Gamma)*(M(2,3)*M(1,1)*uc+M(2,2)^2*uc*eps-M(2,3)*D(2,2)*eps...
    +M(2,3)*D(2,3)-M(2,2)*M(1,1)*uc*eps-M(2,2)*M(2,3)*uc-M(2,2)*D(3,3)...
    +M(2,2)*D(3,2)*eps);
F=(1/Gamma)*(M(2,3)*D(2,2)-M(2,2)^2*uc...
    -M(2,2)*D(3,2)+M(2,2)*M(1,1)*uc);


Theta=(1/Gamma)*(-2*M(2,3)*M(2,2)*eps+M(2,2)^2*eps^2+M(2,3)^2-M(2,2)*M(1,1)*eps^2-M(3,3)*M(1,1)+2*M(2,3)*M(1,1)*eps);
Mm=(1/Gamma)*(M(2,3)*D(3,3)-eps*M(2,2)*D(3,3)-M(3,3)*D(2,3)-M(2,3)*D(3,2)*eps+eps*M(2,3)*D(2,3)+M(2,2)*D(3,2)*eps^2+M(3,3)*D(2,2)*eps-M(2,3)*D(2,2)*eps^2);
Xi=(1/Gamma)*(M(2,2)*M(1,1)*eps-M(2,2)^2*eps-M(2,3)*M(1,1)+M(2,2)*M(2,3));
N=(1/Gamma)*(M(2,3)*D(2,2)*eps-M(2,2)*D(3,2)*eps-M(3,3)*D(2,2)+M(2,3)*D(3,2));
%% init states %%
psi0=0; 
v0=0.05;
r0=-0.05;

xk=[4; 3+eps*sin(psi0); psi0; v0; v0+eps*r0; r0];

nu(1)=uc;
nu(2)=xk(4);
nu(3)=xk(6);

eta(1)=-1;
eta(2)=xk(1);
eta(3)=xk(3);
vsk=xk(5);
ysk=xk(2);

nu=nu';
eta=eta';
eta01=eta;
nu01=nu;
%% end init states %%
%% init input %%
Deltainit=0.51;
dDeltainit=0*0.05/Ts;

Uopt=getInitU3(Deltainit,dDeltainit,Ts,Hu);
Uoptini=Uopt;
uk=Uopt(1:1:3,1);
%% end init input %%


options=optimset('LargeScale','off');
%% end veighting matrix %%

%% run simulation %%
j=1;
k=1;
sample=1;
dUp=zeros(length(Uopt),1);

xkm=xk;

Xreal=zeros(floor(stopp/ts),1);
Ureal=Xreal;
Deltak=zeros(3,floor(stopp/ts));
udes=zeros(2,floor(stopp/ts));
dUk=Deltak;
psireal=Xreal;
rreal=Xreal;
Yreal=Xreal;
dYsk=Xreal;
thetak=getThetak(wp(1,:),wp(2,:),0);

kr=1;

ykr=(eta(2)-wp(kr+1,2))*cos(thetak)-(eta(1)-wp(kr+1,1))*sin(thetak);
yskr=ykr+eps*sin(eta(3)-thetak);
psikr=eta(3)-thetak;
%when we move to the next way-point
when=zeros(10,1);
a1=0;
z1=0;
z2=0;
psid=-atan2(yskr,uk(1))+thetak;
notNow=0;
thetarot=zeros(4,1);
thetarot(1)=thetak;
psis=psireal;
limit=2;
uc=Uopt(3*Hu+1);
duc=Uopt(3*Hu+2);
%% observer gains %%
T=[40 0 0;0 40 0;0 0 100];
K2=[20 0 0;0 20 0;0 0 6];
K3=[60000 0 0;0 60000 0;0 0 100];
K4=[4000 0 0;0 4000 0;0 0 25];
%% end obs gains %%
eta0=eta01;
nu0=nu01;
yt=eta0*0;
yh=eta0;
etahk=eta0;
nuhk=nu0;
bhk=eta0*0;
obsError=zeros(3,stopp/ts);
obsEta=obsError;
obsNu=obsError;
r=Xreal;
v=r;
u=v;
obsB=zeros(2,stopp/ts);
bch=0;
Vch=0;
doh=0;
hack=0;
kvec=[0;0];
psidT=rreal;
errorY=Yreal;
%% run simulation
tic
for i=step:step:stopp,
%% time to sample and optimize
    if sample==1,
        h=sqrt((wp(kr+1,2)-eta(2))^2+(wp(kr+1,1)-eta(1))^2);
%% move to next way-point
        if h<limit&&kr<endSim-1,
            when(kr)=k;
            kr=kr+1;
            thetak=getThetak(wp(kr,:),wp(kr+1,:),thetak);
            ykrn=(eta(2)-wp(kr+1,2))*cos(thetak)-(eta(1)-wp(kr+1,1))*sin(thetak);

            psikrn=eta(3)-thetak;
            
            yskrn=ykrn+eps*sin(psikrn);
            
            a1n=nu(1)*sin(psikrn)+vsk*cos(psikrn);%ysprikk
            a3=(Theta*nu(1)+Mm)*nu(3)+(Xi*nu(1)+N)*vsk;%vskprikk
            a2n=nu(3)*cos(psikrn)*nu(1)-nu(3)*sin(psikrn)*vsk+a3*cos(psikrn)+(duc-ku*(nu(1)-uc))*sin(psikrn);%ystrek dobbel prikk           
%             [Deltainit,dDeltainit,ddDeltainit]=getNewDdeltainit(psid,rd,yskrn,a1n,a2n,a4,thetak);
            [Deltainit]=getNewDdeltainit(psid,rd,yskrn,a1n,a2n,a4,thetak);
%            Uopt=getInitU32(Deltainit,dDeltainit,ddDeltainit,Ts,Hu);    
            Uopt(1:1:3)=[Deltainit;0;0];
            uk=Uopt(1:1:3);

            ykr=(eta(2)-wp(kr+1,2))*cos(thetak)-(eta(1)-wp(kr+1,1))*sin(thetak);
            yskr=ykr+eps*sin(psikrn);
            notNow=1;
            thetarot(kr)=thetak;
            psid=-atan2(yskr,uk(1))+thetak;
        end
%% perform optimization        
        ykr=(eta(2)-wp(kr+1,2))*cos(thetak)-(eta(1)-wp(kr+1,1))*sin(thetak);
        xkm=[ykr;yskr;eta(3)-thetak;nu(1)-uc;nu(2);vsk;nu(3)];
        
        uprev(1:1:3)=uk;
        uprev(4:5)=Uopt(3*Hu+1:1:3*Hu+2);
        [A,b,Aeq,beq,lb,ub]=constrFmincon4(umin,Hu,uprev,Ts,hack);
        %[Uopt,dUp]=MPC2(xkm,Uopt,Hu,Hp,Ts,dUp,Q);
        if notNow==0,
            Uoptt=zeros(5*Hu,1);
            Uoptt(1:1:3*Hu-3)=Uopt(4:1:3*Hu);
            Uoptt(3*Hu-2)=0.51;
            Uoptt(3*Hu+1:1:5*Hu)=Uopt(3*Hu+1:1:5*Hu);
            Uopt=Uoptt;
        end
        notNow=0;
        eta0=eta;
        nu0=nu;
%         jadda=length(Uopt);
%         masa=length(lb);
        currk=[bch-thetak;Vch];
%         if Uopt(1)<0.5,
%             Uopt(1:1:3*Hu)=zeros(3*Hu,1);
%             Uopt(1:3:3*Hu-2)=0.5;
%             [A,b,Aeq,beq,lb,ub]=constrFmincon4(umin,Hu,[0.5;0;0;0.2;0],Ts);
% %             hey(k)=Uopt(1);
%         end
        Uopt=fmincon(@objectiveF4,Uopt,[],[],Aeq,beq,lb,ub,[],options);
%% sample
        errorY(k)=(0.08*eta(2)+a1);
        Yreal(k)=eta(2);
        Xreal(k)=eta(1);
        psis(k)=eta(3)-thetak;
        psireal(k)=eta(3);
        rreal(k)=psid-thetak;
        psidT(k)=psid;
        Ureal(k)=ykr;
        dYsk(k)=nu(1);
        %sample=0;
        Deltak(:,k)=uk;
        v(k)=nu(2);
        r(k)=nu(3);
        u(k)=nu(1);
        udes(:,k)=[uc;duc];
        obsError(:,k)=yt;
        obsEta(:,k)=etahk;
        obsNu(:,k)=nuhk;
        obsB(:,k)=[bch;Vch];
%         plotHack(:,k)=[hack;kvec(1);kvec(2)];
        
    end
%     if k==111,
%         break;
%     end
%% new inputs   
    uc=Uopt(3*Hu+1);
    duc=Uopt(3*Hu+2);
    uk=Uopt(1:1:3);

%% states in rotated reference frame %%%

    ykr=(eta(2)-wp(kr+1,2))*cos(thetak)-(eta(1)-wp(kr+1,1))*sin(thetak);
    psikr=eta(3)-thetak;
    vsk=nu(2)+eps*nu(3);
    yskr=ykr+eps*sin(psikr);
    
    denum=uk(1)^2+yskr^2;
%% derivatives
    a1=nu(1)*sin(psikr)+vsk*cos(psikr);%ysprikk
    a3=(Theta*nu(1)+Mm)*nu(3)+(Xi*nu(1)+N)*vsk;%vskprikk
    a2=nu(3)*cos(psikr)*nu(1)-nu(3)*sin(psikr)*vsk+a3*cos(psikr)+(duc-ku*(nu(1)-uc))*sin(psikr);%ystrek dobbel prikk
    a4=2*(uk(1)*uk(2)+yskr*a1)*(uk(1)*a1-yskr*uk(2))/...
        denum^2+(yskr*uk(3)-uk(1)*a2)/denum;%rdprikk
%% desired state and tracking errors 
    rd=(-uk(1)*a1+yskr*uk(2))/denum;%desired heading rate
    psid=-atan2(yskr,uk(1))+thetak;
    z1=eta(3)-psid;%tracking error heading
    z2=nu(3)-rd;%tracking error heading rate
%% evaluate control input 
    
    delta=Gamma*(-Omega*nu(3)-F*vsk+a4-k1*z2-k0*z1)/...
        (M(2,2)*Nd-M(2,3)*Yd);

    tauu=-(M(2,2)*nu(2)+M(2,3)*nu(3))*nu(3)+D(1,1)*nu(1)...
        -M(1,1)*ku*(nu(1)-uc);
    if abs(delta)>1.5,
        delta=1.5*delta/abs(delta);
    end
    if abs(tauu)>2,
        tauu=2*tauu/abs(tauu);
    end
    
    tau=[tauu;Yd*delta;Nd*delta];
%% sample controll vector if t=k*ts    
    if sample==1,
        dUk(:,k)=tau;
        sample=0;
    end
%% evaluate relativ velocities %%%
    ucb=current*Vc*cos(betac-eta(3));
    vcb=current*Vc*sin(betac-eta(3));
    ur=nu(1)-ucb;
    vr=nu(2)-vcb;
    nur=[ur;vr;nu(3)];

%% evaluate coriolis matrix %%%
    Cnu=[            0                0 -M(2,2)*nu(2)-M(2,3)*nu(3);
                     0                0               M(1,1)*nu(1);
         M(2,2)*nu(2)+M(2,3)*nu(3)   -M(1,1)*nu(1)             0];
    
%% integrate nu %%%
    nu1=nu+step*(-M^(-1)*(Cnu*nu+D*nur-tau));
    if abs(nu1(3))>0.8,
        nu1(3)=0.8*nu1(3)/abs(nu1(3));
    end
%% evaluate rotaion matrix %%%
    R=[cos(eta(3)) -sin(eta(3)) 0;
       sin(eta(3))  cos(eta(3)) 0;
                0            0  1];
    
%% integrate eta %%%
    eta1=eta+step*R*nu1;

%% determine if next itteration should be sampled
    if j==ts/step+1,
        j=1;
        sample=1;
        k=k+1;
    end

%% observer %%
    Cnuh=[            0                0 -M(2,2)*nuhk(2)-M(2,3)*nuhk(3);
                      0                0                 M(1,1)*nuhk(1);
          M(2,2)*nuhk(2)+M(2,3)*nuhk(3) -M(1,1)*nuhk(1)               0];
         
    yt=eta-yh;
    bhk1=bhk+step*(-T^(-1)*bhk+K3*yt);
    nuhk1=nuhk+step*M^(-1)*(tau-D*nuhk-Cnuh*nuhk+R'*bhk+R'*K4*yt);
    etahk1=etahk+step*(R*nuhk1+K2*yt);
    kvec=D^(-1)*R'*bhk;
%% find current
    bch=atan2(kvec(2),kvec(1))+eta(3);
    if abs(bch)>=2*pi,
        bch=bch-bch/abs(bch)*2*pi;
    end
    Vch=kvec(1)/cos(bch-eta(3));
    yh=etahk1;
    etahk=etahk1;
    bhk=bhk1;
    nuhk=nuhk1;

%% end obs %%
%% make shure heading angle is in [-2*pi 2*pi]
    if eta1(3)>=2*pi,
        eta1(3)=eta1(3)-2*pi;
        thetak=thetak-2*pi;
        etahk(3)=etahk(3)-2*pi;
        yh(3)=etahk(3);
        psid=-atan2(yskr,uk(1))+thetak;
    end
    if eta1(3)<=-2*pi;
        eta1(3)=eta1(3)+2*pi;
        thetak=thetak+2*pi;
        etahk(3)=etahk(3)+2*pi;
        yh(3)=etahk(3);
        psid=-atan2(yskr,uk(1))+thetak;
    end 
    nu=nu1;
    eta=eta1;
    j=j+1;

end
%% end simulation %%
toc
%% obtain reference %%
uk=[6;0;0];
uk2=[3;0;0];
[YrealRef1,XrealRef1,UrealRef,crossE1,psiRef1]=mainReference(eta01,nu01,uk,step,stopp,ts,thetarot,endSim,wp,limit,current,Vc,betac);
[YrealRef2,XrealRef2,UrealRef2,crossE2,psiRef2]=mainReference(eta01,nu01,uk2,step,stopp,ts,thetarot,endSim,wp,limit,current,Vc,betac);
%% find sum of squared cross track errors
sumErrorSq3Ulu=Ureal'*Ureal;
sumErrorSq1Ulu=crossE1'*crossE1;
sumErrorSq2Ulu=crossE2'*crossE2;
%% plot path
figure(9);
plot(Yreal,Xreal);
hold on
plot(wp(:,2),wp(:,1),'r');
plot(YrealRef1,XrealRef1,':');
plot(YrealRef2,XrealRef2,'--');
title('Desired path vs actual path for \Delta from MPC and \Delta constant');
legend('Path for \Delta(t)','Desired path','Path for \Delta=6','Path for \Delta=3');
% %% plot heading
% figure(13);
% plot(psidT)
%% plot cross-track error,delta(t),heading and surge speed
% figure(7);
% hold off;
% subplot(4,1,1);
% plot(ts:ts:stopp,Ureal);
% hold on;
% plot(ts:ts:stopp,crossE1,':');
% plot(ts:ts:stopp,crossE2,'--');
% plot(ts:ts:stopp,zeros(length(Xreal),1),'r');
% title('Cross track error');
% legend('\Delta(t) from MPC','Constant \Delta=6','Constant \Delta=3');
% xlabel('t [s]');
% ylabel('y(t) [m]');
% subplot(4,1,2);
% plot(ts:ts:stopp,Deltak(1,:));
% title('\Delta(t) from MPC')
% xlabel('t [s]');
% ylabel('\Delta(t) [m]');
% subplot(4,1,3);
% plot(ts:ts:stopp,psis);
% hold on;
% plot(ts:ts:stopp,rreal,':');
% title('Heading vs Desired Heading');
% legend('\psi(t)','\psi_d(t)');
% xlabel('t [s]');
% ylabel('\Psi(t) [rad]');
% subplot(4,1,4);
% plot(ts:ts:stopp,dYsk);
% hold on;
% plot(ts:ts:stopp,udes(1,:),':');
% title('Surge Velocity vs Desired Surge Velocity')
% legend('u(t)','u_d(t)');
% xlabel('t [s]');
% ylabel('u(t) [m/s]');
figure(10);
hold off;
subplot(3,1,1);
plot(ts:ts:stopp,Ureal);
hold on;
plot(ts:ts:stopp,crossE1,':');
plot(ts:ts:stopp,crossE2,'--');
plot(ts:ts:stopp,zeros(length(Xreal),1),'r');
title('Cross track error');
legend('\Delta(t) from MPC','Constant \Delta=6','Constant \Delta=3');
xlabel('t [s]');
ylabel('y(t) [m]');
subplot(3,1,2);
plot(ts:ts:stopp,Deltak(1,:));
title('\Delta(t) from MPC')
xlabel('t [s]');
ylabel('\Delta(t) [m]');
subplot(3,1,3);
plot(ts:ts:stopp,psis);
hold on;
plot(ts:ts:stopp,rreal,':');
title('Heading vs Desired Heading');
legend('\psi(t)','\psi_d(t)');
xlabel('t [s]');
ylabel('\Psi(t) [rad]');
% plot(psiRef1,':');
% plot(psiRef2,':');
%% plot observer error
% figure(11);
% subplot(3,1,1);
% plot(obsError(1,:));
% subplot(3,1,2);
% plot(obsError(2,:));
% subplot(3,1,3);
% plot(obsError(3,:));
% %%
% % figure(12);
% % subplot(3,1,1);
% % plot(obsEta(1,:));
% % hold on;
% % plot(Xreal,':');
% % subplot(3,1,2);
% % plot(obsEta(2,:));
% % hold on;
% % plot(Yreal,':');
% % subplot(3,1,3);
% % plot(obsEta(3,:));
% % hold on;
% % plot(psis,':');
% %% plot observed velocities
% figure(13);
% subplot(3,1,1);
% plot(obsNu(1,:));
% hold on;
% plot(u,':');
% subplot(3,1,2);
% plot(obsNu(2,:));
% hold on;
% plot(v,':');
% subplot(3,1,3);
% plot(obsNu(3,:));
% hold on;
% plot(r,':');
% %% plot observed current
% figure(14);
% subplot(2,1,1);
% plot(obsB(1,:));
% hold on;
% plot(betac*ones(length(obsB),1),':')
% subplot(2,1,2);
% plot(obsB(2,:));
% hold on;
% plot(Vc*ones(length(obsB),1),':')
%%

% figure(100);
% subplot(3,1,1)
% plot(plotHack(1,:));
% subplot(3,1,2)
% plot(plotHack(2,:));
% subplot(3,1,3)
% plot(plotHack(3,:));