function [YrealRef,XrealRef,UrealRef,crossError,psiRef,v,r,dy]=mainReference(eta0,nu0,uk,step,stopp,ts,thetarot,endSim,wp,limit,current,Vc,betac)


thetak=thetarot(1);
XrealRef=zeros(round(stopp/ts),1);
UrealRef=zeros(round(stopp/ts),3);
ku=5;
uc=0.2;

k0=10;
k1=sqrt(4*k0);

%% Model %%
M=[25.8 0 0;0 33.8 1.0115;0 1.0115 2.76];
D=[0.9257 0 0;0 2.8909 -0.2601;0 -0.2601 0.5];
%%% hydrodyn param %%%
Nd=1;
Yd=-0.2;
%%% end hydrodyn %%%
Gamma=M(2,2)*M(3,3)-M(2,3)^2;
eps=-(M(3,3)*Yd-M(2,3)*Nd)/(M(2,2)*Nd-M(2,3)*Yd);
Omega=(1/Gamma)*(M(2,3)*M(1,1)*uc+M(2,2)^2*uc*eps-M(2,3)*D(2,2)*eps...
    +M(2,3)*D(2,3)-M(2,2)*M(1,1)*uc*eps-M(2,2)*M(2,3)*uc-M(2,2)*D(3,3)...
    +M(2,2)*D(3,2)*eps);
F=(1/Gamma)*(M(2,3)*D(2,2)-M(2,2)^2*uc...
    -M(2,2)*D(3,2)+M(2,2)*M(1,1)*uc);


Theta=(1/Gamma)*(-2*M(2,3)*M(2,2)*eps+M(2,2)^2*eps^2+M(2,3)^2-M(2,2)*M(1,1)*eps^2-M(3,3)*M(1,1)+2*M(2,3)*M(1,1)*eps);
Mm=(1/Gamma)*(M(2,3)*D(3,3)-eps*M(2,2)*D(3,3)-M(3,3)*D(2,3)-M(2,3)*D(3,2)*eps+eps*M(2,3)*D(2,3)+M(2,2)*D(3,2)*eps^2+M(3,3)*D(2,2)*eps-M(2,3)*D(2,2)*eps^2);
Xi=(1/Gamma)*(M(2,2)*M(1,1)*eps-M(2,2)^2*eps-M(2,3)*M(1,1)+M(2,2)*M(2,3));
N=(1/Gamma)*(M(2,3)*D(2,2)*eps-M(2,2)*D(3,2)*eps-M(3,3)*D(2,2)+M(2,3)*D(3,2));
%% init states %%

nu=nu0;
eta=eta0;

% vsk=xk(5);
% ysk=xk(2);
crossError=XrealRef;
psiRef=XrealRef;
YrealRef=XrealRef;
v=XrealRef;
r=XrealRef;
dy=v;
%% end init states %%

%% run simulation %%
j=1;
k=1;
sample=1;
kr=1;
ykr=(eta(2)-wp(kr+1,2))*cos(thetak)-(eta(1)-wp(kr+1,1))*sin(thetak);
% eta(3)=atan2(3.3,3)-thetak; 
% yskr=ykr+eps*sin(eta(3)-thetak);
% psikr=eta(3)-thetak;

for i=step:step:stopp,
     h=sqrt((wp(kr+1,2)-eta(2))^2+(wp(kr+1,1)-eta(1))^2);
        %move to next way-point

    if sample==1,
%         if when(kr)>0,
%             if when(kr)==k,
%                 thetak=thetarot(kr+1);
%                 kr=kr+1;
%             end
%         end
        if h<limit&&kr<endSim-1,
            
            kr=kr+1;
            thetak=getThetak(wp(kr,:),wp(kr+1,:),thetak);
        end
        ykr=(eta(2)-wp(kr+1,2))*cos(thetak)-(eta(1)-wp(kr+1,1))*sin(thetak);
        psikr=eta(3)-thetak;
        crossError(k)=ykr;
        psiRef(k)=eta(3);
%         yskr=ykr+eps*sin(psikr);
%         psiRef(k)=-(atan2(yskr,uk(1))-thetak);
        XrealRef(k)=eta(1);
        YrealRef(k)=eta(2);
        v(k)=nu(2);
        r(k)=nu(3);
        dy(k)=nu(1)*sin(psikr)+nu(2)*cos(psikr);

%         sample=0;
    end
    

    %%% derivatives %%%
    ykr=(eta(2)-wp(kr+1,2))*cos(thetak)-(eta(1)-wp(kr+1,1))*sin(thetak);
    psikr=eta(3)-thetak;
    vsk=nu(2)+eps*nu(3);
    yskr=ykr+eps*sin(psikr);
    
    denum=uk(1)^2+yskr^2;

    a1=nu(1)*sin(psikr)+vsk*cos(psikr);%ysprikk
    a3=(Theta*uc+Mm)*nu(3)+(Xi*uc+N)*vsk;%vskprikk
    a2=nu(3)*cos(psikr)*uc-nu(3)*sin(psikr)*vsk+a3*cos(psikr);%ystrek dobbel prikk
    a4=2*(uk(1)*uk(2)+yskr*a1)*(uk(1)*a1-yskr*uk(2))/...
        denum^2+(yskr*uk(3)-uk(1)*a2)/denum;%rdprikk

    %%% desired state and tracking errors %%%
    rd=(-uk(1)*a1+yskr*uk(2))/denum;%desired heading rate

    z1=eta(3)+atan2(yskr,uk(1))-thetak;%tracking error heading
    z2=nu(3)-rd;
    
    %%% evaluate control input %%%
    delta=Gamma*(-Omega*nu(3)-F*vsk+a4-k1*z2-k0*z1)/...
        (M(2,2)*Nd-M(2,3)*Yd);
    if abs(delta)>1.5,
        delta=1.5*delta/abs(delta);
    end
    tauu=-(M(2,2)*nu(2)+M(2,3)*nu(3))*nu(3)+D(1,1)*nu(1)...
        -M(1,1)*ku*(nu(1)-uc);
    tau=[tauu;Yd*delta;Nd*delta];
    if sample==1,
        UrealRef(k,:)=tau;
        sample=0;
    end
    %% evaluate relativ velocities %%%
    ucb=current*Vc*cos(betac-eta(3));
    vcb=current*Vc*sin(betac-eta(3));
    ur=nu(1)-ucb;
    vr=nu(2)-vcb;
    nur=[ur;vr;nu(3)];

    %%% evaluate coriolis matrix %%%
    Cnu=[            0                0 -M(2,2)*nu(2)-M(2,3)*nu(3);
                     0                0               M(1,1)*nu(1);
         M(2,2)*nu(2)+M(2,3)*nu(3)   -M(1,1)*nu(1)             0];
    
    %%% integrate nu %%%
    nu1=nu+step*(-M^(-1)*(Cnu*nu+D*nur-tau));
    %%% evaluate rotaion matrix %%%
    R=[cos(eta(3)) -sin(eta(3)) 0;
       sin(eta(3))  cos(eta(3)) 0;
                0            0  1];
    
    %%% integrate eta %%%
    eta1=eta+step*R*nu1;
        
    %%% sample at each time Ts %%%
    if j==round(ts/step)+1,
        j=1;
        sample=1;
        k=k+1;
    end
    %% make shure heading angle is in [-2*pi 2*pi]
    if eta1(3)>=2*pi,
        eta1(3)=eta1(3)-2*pi;
        thetak=thetak-2*pi;
    end
    if eta1(3)<=-2*pi;
        eta1(3)=eta1(3)+2*pi;
        thetak=thetak+2*pi;
    end
    
    %step to time t+step
%     vsk=vsk1;
%     ysk=ysk1;
    nu=nu1;
    eta=eta1;
    j=j+1;
end
%% end simulation %%