clear all;
step=0.05;
%% begin param to produce results
%% set simulation time in seconds
stopp=110;
%% choose cost function
cost=2;%0=Q1, 1=Q2,2=Q3

%% set current and current param%%
current=1;
Vc=0.01;
betac=pi/3;
%% set prediction horizon
Hp=80;
Hu=25;
%% end paramt to produce results
ts=0.3;
Ts=ts;
Xreal=zeros(Hp,1);
Ureal=zeros(Hp,1);
ku=5;
uc=0.2;
k0=10;
k1=sqrt(4*k0);
duTuo=zeros(3*Hu,3*Hu);
for i=1:3:3*Hu,
    for j=i:3:3*Hu,
        duTuo(j:1:2+j,i:1:2+i)=eye(3);
    end
end
hack=zeros(Hu-1,1);
for i=2:1:Hu-1,
    hack(i)=i*0.0001;
end

%% Model %%
M=[25.8 0 0;0 33.8 1.0115;0 1.0115 2.76];
D=[0.9257 0 0;0 2.8909 -0.2601;0 -0.2601 0.5];
%% hydrodyn param %%%
Nd=1;
Yd=-0.2;
%% end hydrodyn %%%
Gamma=M(2,2)*M(3,3)-M(2,3)^2;
eps=-(M(3,3)*Yd-M(2,3)*Nd)/(M(2,2)*Nd-M(2,3)*Yd);
Omega=(1/Gamma)*(M(2,3)*M(1,1)*uc+M(2,2)^2*uc*eps-M(2,3)*D(2,2)*eps...
    +M(2,3)*D(2,3)-M(2,2)*M(1,1)*uc*eps-M(2,2)*M(2,3)*uc-M(2,2)*D(3,3)...
    +M(2,2)*D(3,2)*eps);
F=(1/Gamma)*(M(2,3)*D(2,2)-M(2,2)^2*uc...
    -M(2,2)*D(3,2)+M(2,2)*M(1,1)*uc);


Theta=(1/Gamma)*(-2*M(2,3)*M(2,2)*eps+M(2,2)^2*eps^2+M(2,3)^2-M(2,2)*M(1,1)*eps^2-M(3,3)*M(1,1)+2*M(2,3)*M(1,1)*eps);
Mm=(1/Gamma)*(M(2,3)*D(3,3)-eps*M(2,2)*D(3,3)-M(3,3)*D(2,3)-M(2,3)*D(3,2)*eps+eps*M(2,3)*D(2,3)+M(2,2)*D(3,2)*eps^2+M(3,3)*D(2,2)*eps-M(2,3)*D(2,2)*eps^2);
Xi=(1/Gamma)*(M(2,2)*M(1,1)*eps-M(2,2)^2*eps-M(2,3)*M(1,1)+M(2,2)*M(2,3));
N=(1/Gamma)*(M(2,3)*D(2,2)*eps-M(2,2)*D(3,2)*eps-M(3,3)*D(2,2)+M(2,3)*D(3,2));
%% init states %%
psi0=-1;
v0=0.05;
r0=-0.05;
xk=[3; 3+eps*sin(psi0); psi0; v0; v0+eps*r0; r0];
nu(1)=uc;
nu(2)=xk(4);
nu(3)=xk(6);
eta(1)=0;
eta(2)=xk(1);
eta(3)=xk(3);
vsk=xk(5);
ysk=xk(2);

nu=nu';
eta=eta';
eta0=eta;
nu0=nu;
%% end init states %%
%% init input %%
Deltainit=2;
dDeltainit=0.05/Ts;
Uopt=getInitU(Deltainit,dDeltainit,Ts,Hu);
%% end init input %%
%% form veigthing matrix %%
Q=zeros(6*Hp,6*Hp);
Rw=zeros(3*Hu,3*Hu);
end1=0;
end2=0;
end3=0;
for i=1:1:Hp,
%     if i==Hp,
%         end1=0;
%         end2=0;%k her for kt delta nr y->0
%         end3=0;
%     end
    if cost==0,
        Q((i-1)*6+1:1:(i-1)*6+6,(i-1)*6+1:1:(i-1)*6+6)=...%fig21 0.01 og 0.2 hp=200
                10^4*[3 0 0 0 0 0;
                 0 0 0 0 0 0
                 0 0 1 0 0 0
                 0 0 0 0 0 0
                 0 0 0 0 0 0
                 0 0 0 0 0 0];
    elseif cost==1,
        Q((i-1)*6+1:1:(i-1)*6+6,(i-1)*6+1:1:(i-1)*6+6)=...%fig21 0.01 og 0.2 hp=200
                10^4*[3 0 0 0 0 0;
                 0 0 0 0 0 0
                 0 0 4 0 0 0
                 0 0 0 0 0 0
                 0 0 0 0 0 0
                 0 0 0 0 0 0];
    elseif cost==2,
        Q((i-1)*6+1:1:(i-1)*6+6,(i-1)*6+1:1:(i-1)*6+6)=...%fig21 0.01 og 0.2 hp=200
                10^4*[3 0 0 0 0 0;
                 0 0 0 0 0 0
                 0 0 1 0 0 0
                 0 0 0 0 0 0
                 0 0 0 0 0 0
                 0 0 0 0 0 1];
    end
    
    if i<=Hu,
        Rw((i-1)*3+1:1:(i-1)*3+3,(i-1)*3+1:1:(i-1)*3+3)=[10 0 0;
                                                        0 100 0;
                                                        0 0 1000];
    end
end
%% end veighting matrix %%
%% observer gains %%
T=[40 0 0;0 40 0;0 0 100];
K2=[20 0 0;0 20 0;0 0 6];
K3=[60000 0 0;0 60000 0;0 0 100];
K4=[4000 0 0;0 4000 0;0 0 25];
%% end obs gains %%
%% init observer %%
thetak=0;
yt=eta0*0;
yh=eta0;
etahk=eta0;
nuhk=nu0;
bhk=eta0*0;
obsError=zeros(3,round(stopp/ts));
obsEta=obsError;
obsNu=obsError;
bch=0;
Vch=0;
%% end %%

%% init param %%
j=1;
k=1;
sample=1;
dUp=zeros(length(Uopt),1);

xkm=xk;

Xreal=zeros(floor(stopp/ts),1);
Ureal=Xreal;
Deltak=zeros(3,floor(stopp/ts));
dUk=zeros(3,floor(stopp/ts));
psireal=Xreal;
rreal=Xreal;

uk=Uopt(1:1:3);
ud=0.2;
dud=0;
psisd=psireal;
psid=-atan2(ysk,uk(1));
obsB=zeros(2,floor(stopp/ts));
%% run simulation %%
tic
for i=step:step:stopp,
    
    if sample==1,
        xkm=[eta(2);ysk;eta(3);nu(2);vsk;nu(3)];
        currk=[bch-thetak;Vch];
        [Uopt,dUp,Fc,f1,Aeq,beq,lb,ub,G]=MPCqp(xkm,Uopt,Hu,Hp,Ts,dUp,Q,Rw,duTuo,hack,currk,current);
        %break;
        Xreal(k)=eta(2);
        psireal(k)=eta(3);
        rreal(k)=nu(3);
        Ureal(k)=nu(2);
        %sample=0;
        Deltak(:,k)=Uopt(1:1:3);
        psisd(k)=psid;
        uk=Uopt(1:1:3);
        obsB(:,k)=[bch;Vch];
    end
    vsk=nu(2)+eps*nu(3);
    ysk=eta(2)+eps*sin(eta(3));
    denum=uk(1)^2+ysk^2;
%% derivatives %%%
    a1=nu(1)*sin(eta(3))+vsk*cos(eta(3));%ysprikk
    a3=(Theta*ud+Mm)*nu(3)+(Xi*ud+N)*vsk;%vskprikk
    a2=nu(3)*cos(eta(3))*ud+sin(eta(3))*(dud-ku*(nu(1)-ud))-nu(3)*sin(eta(3))*vsk+a3*cos(eta(3));%ystrek dobbel prikk
    a4=2*(uk(1)*uk(2)+ysk*a1)*(uk(1)*a1-ysk*uk(2))/...
        denum^2+(ysk*uk(3)-uk(1)*a2)/denum;%rdprikk

%% desired state and tracking errors %%%
    rd=(-uk(1)*a1+ysk*uk(2))/denum;%desired heading rate
    psid=-atan2(ysk,uk(1));
    z1=eta(3)-psid;%tracking error heading
    z2=nu(3)-rd;%tracking error heading rate
    
%% evaluate control input %%%
    delta=Gamma*(-Omega*nu(3)-F*vsk+a4-k1*z2-k0*z1)/...
        (M(2,2)*Nd-M(2,3)*Yd);
%% constraint on rudder moment %%%
    if abs(delta)>1.5,
        delta=1.5*delta/abs(delta);
    end

    tauu=-(M(2,2)*nu(2)+M(2,3)*nu(3))*nu(3)+D(1,1)*nu(1)...
        -M(1,1)*ku*(nu(1)-ud);
%% constraint on surge force
    if abs(tauu)>2,
        tauu=2*tauu/abs(tauu);
    end
    tau=[tauu;Yd*delta;Nd*delta];
    if sample==1,
        dUk(:,k)=tau;
        sample=0;
    end
%% evaluate relativ velocities %%%
    ucb=current*Vc*cos(betac-eta(3));
    vcb=current*Vc*sin(betac-eta(3));
    ur=nu(1)-ucb;
    vr=nu(2)-vcb;
    nur=[ur;vr;nu(3)];
%% evaluate coriolis matrix %%%
    Cnu=[            0                0 -M(2,2)*nu(2)-M(2,3)*nu(3);
                     0                0               M(1,1)*nu(1);
         M(2,2)*nu(2)+M(2,3)*nu(3)   -M(1,1)*nu(1)             0];
    
%% integrate nu %%%
    nu1=nu+step*(-M^(-1)*(Cnu*nu+D*nur-tau));
%% evaluate rotaion matrix %%%
    R=[cos(eta(3)) -sin(eta(3)) 0;
       sin(eta(3))  cos(eta(3)) 0;
                0            0  1];
    
%% integrate eta %%%
    eta1=eta+step*R*nu1;
        
%% sample at each time Ts %%%
    if j==round(ts/step)+1,
        j=1;
        sample=1;
        k=k+1;
    end
%% observer %%
    Cnuh=[            0                0 -M(2,2)*nuhk(2)-M(2,3)*nuhk(3);
                      0                0                 M(1,1)*nuhk(1);
          M(2,2)*nuhk(2)+M(2,3)*nuhk(3) -M(1,1)*nuhk(1)               0];
         
    yt=eta-yh;
    bhk1=bhk+step*(-T^(-1)*bhk+K3*yt);
    nuhk1=nuhk+step*M^(-1)*(tau-D*nuhk-Cnuh*nuhk+R'*bhk+R'*K4*yt);
    etahk1=etahk+step*(R*nuhk1+K2*yt);
    kvec=D^(-1)*R'*bhk;
%% find current
    bch=atan2(kvec(2),kvec(1))+eta(3);
    if abs(bch)>=2*pi,
        bch=bch-bch/abs(bch)*2*pi;
    end
    Vch=kvec(1)/cos(bch-eta(3));
    yh=etahk1;
    etahk=etahk1;
    bhk=bhk1;
    nuhk=nuhk1;

%% end obs %%
    
    %step to time t+step
%    vsk=vsk1;
%    ysk=ysk1;
    nu=nu1;
    eta=eta1;
    j=j+1;
    
end
%% end simulation %%
toc
%% obtain reference %%
uk=[6;0;0];
uk2=[3;0;0];
[XrealRef,UrealRef]=mainReference(eta0,nu0,uk,step,stopp,ts,[0 0],1,[0 0;0 0],0,current,Vc,betac);
[XrealRef2,UrealRef2]=mainReference(eta0,nu0,uk2,step,stopp,ts,[0 0],1,[0 0;0 0],0,current,Vc,betac);
figure(1);
hold off;
subplot(3,1,1);
plot(ts:ts:k*ts,Xreal);
hold on;
plot(ts:ts:k*ts,XrealRef2,':');
plot(ts:ts:k*ts,XrealRef,':');
plot(ts:ts:k*ts,zeros(length(Xreal),1),'r');
title('Cross track error');
legend('\Delta(t) from MPC','Constant \Delta=6','Constant \Delta=3');
xlabel('t [s]');
ylabel('y(t) [m]');
xlim([0 k*ts]);
subplot(3,1,2);
plot(ts:ts:k*ts,Deltak(1,:));
title('\Delta(t) from MPC')
xlabel('t [s]');
ylabel('\Delta(t) [m]');
xlim([0 k*ts]);
subplot(3,1,3);
plot(ts:ts:k*ts,psireal);
hold on;
plot(ts:ts:k*ts,psisd,':');
plot(ts:ts:k*ts,zeros(length(Xreal),1),'r');
title('Heading vs Desired Heading');
legend('\psi(t)','\psi_d(t)');
xlabel('t [s]');
ylabel('\Psi(t) [rad]');
xlim([0 k*ts]);

% figure(1);
% hold off;
% subplot(4,1,1);
% plot(ts:ts:k*ts,Xreal);
% hold on;
% plot(ts:ts:k*ts,XrealRef2,':');
% plot(ts:ts:k*ts,XrealRef,':');
% plot(ts:ts:k*ts,zeros(length(Xreal),1),'r');
% title('Cross track error');
% legend('\Delta(t) from MPC','Constant \Delta=6','Constant \Delta=3');
% xlabel('t [s]');
% ylabel('y(t) [m]');
% xlim([0 k*ts]);
% subplot(4,1,2);
% plot(ts:ts:k*ts,Deltak(1,:));
% title('\Delta(t) from MPC');
% xlabel('t [s]');
% ylabel('\Delta(t) [m]');
% xlim([0 k*ts]);
% subplot(4,1,3);
% plot(ts:ts:k*ts,psireal);
% hold on;
% plot(ts:ts:k*ts,psisd,':');
% plot(ts:ts:k*ts,zeros(length(Xreal),1),'r');
% title('Heading vs Desired Heading');
% legend('\psi(t)','\psi_d(t)');
% xlabel('t [s]');
% ylabel('\Psi(t) [rad]');
% xlim([0 k*ts]);
% subplot(4,1,4);
% plot(ts:ts:k*ts,rreal);
% title('Heading rate');
% xlabel('t [s]');
% ylabel('r(t) [rad/s]');
% xlim([0 k*ts]);
% figure();
% hold off;
% subplot(3,1,1);
% plot(ts:ts:k*ts,Xreal);
% hold on;
% plot(ts:ts:k*ts,XrealRef2,':');
% plot(ts:ts:k*ts,XrealRef,':');
% plot(ts:ts:k*ts,zeros(length(Xreal),1),'r');
% subplot(3,1,2);
% plot(ts:ts:k*ts,Deltak(1,:));
% subplot(3,1,3);
% plot(ts:ts:k*ts,psireal);