%Predict states
function [Xki,Upred] = simXdebug(xk, U, Hu, Hp, ts, s, uc, Theta,N,M,Xi,k0,k1,eps,currk,current)
Upred=zeros(3*Hp,1);                %init Upred

Upred(1:1:3*Hu,1)=U(1:1:3*Hu,1);                %put Upred equal to previous Upred
k=0;
Upred(3*Hu-1,1)=0;
%keep input constant after the input horizon
for j=3*Hu+1:1:3*Hp,
    if k>2,
        k=0;
    end
    if k==0,
        Upred(j,1)=U(3*Hu-2,1);

    else
        Upred(j,1)=0;
    end

    k=k+1;
end

Xki=zeros(Hp*6,1);
yk=xk(1);
ysk=xk(2);
psik=xk(3);
vk=xk(4);
vsk=xk(5);
rk=xk(6);
j=1;
l=1;

for i=s:s:Hp*ts,%integrer med sm steg, sample ved Ts sett inn uk ved Ts
    
    if l==round(ts/s)+1,
        l=1;
        j=j+3;
    end
    vskc=current*currk(2)*sin(currk(1)-psik);
    %%%% dynamics %%%%
    denum=Upred(j)^2+ysk^2;
    a1=uc*sin(psik)+vsk*cos(psik);%ysprikk
    a3=(Theta*uc+M)*rk+(Xi*uc)*vsk+N*(vsk-vskc);%vskprikk(Theta*uk+M)*rk+(Xi*uk)*vsk+N*(vsk-vskc)
    a2=rk*cos(psik)*uc-rk*sin(psik)*vsk+a3*cos(psik);%ystrek dobbel prikk
    a4=2*(Upred(j)*Upred(j+1)+ysk*a1)*(Upred(j)*a1-ysk*Upred(j+1))/...
        denum^2+(ysk*Upred(j+2)-Upred(j)*a2)/denum;%rdprikk   
    rd=(-Upred(j)*a1+ysk*Upred(j+1))/denum;%delta time varying
    z1=psik+atan2(ysk,Upred(j));%avvik psi
    z2=rk-rd;%avvik r
    
    %%%% end dyn %%%%
    
    %%%% integrate %%%%
    vsk1=vsk+s*a3;
    rk1=rk+s*(a4-k1*z2-k0*z1);  
    vk1=vk+s*(a3-eps*(a4-k1*z2-k0*z1));%dotv=dotvs-eps*dotr
    
    % according to fossen eta(k+1)=
    % eta(k)+s(R(eta(k))nu(k+1))
    yk1=yk+s*(uc*sin(psik)+vk1*cos(psik));
    ysk1=ysk+s*(uc*sin(psik)+vsk1*cos(psik));
    psik1=psik+s*rk1;
    
    %%%% end int %%%%
    
    %%% sample to form Xpred at Ts %%%
    %%% evaluate the input vector at each time k=n*Ts
    
    if l==1,
        Xki((j-1)*2+1:1:(j-1)*2+6,1)=[yk1; ysk1; psik1; vk1; vsk1; rk1]; %sjekk om dette funker!!!!!
    end
    l=l+1;
    %%%% step to time k+1 %%%%    
    yk=yk1;
    ysk=ysk1;
    psik=psik1;
    vk=vk1;
    vsk=vsk1;
    rk=rk1;
    
    %%%% end step %%%%
end
%%%%%%  end prediction  %%%%%%%