%Predict states uc is input, u is time varying
function [Xki,Upred,Ud] = simXfmincon3(xk,U,Hu,Hp,ts,s,Theta,N,M,Xi,k0,k1,ku,eps,currk,current)

Upred=zeros(3*Hp,1);                %init Upred
Upsilon=Theta;
Lambda=Xi;
Upred(1:1:3*Hu,1)=U(1:1:3*Hu,1);                %put Upred equal to previous Upred
Ud=U(3*Hu+1:1:length(U));

k=0;
Upred(3*Hu-1,1)=0;
%keep input constant after the input horizon
i=1;
for j=3*Hu+1:1:3*Hp,
    if k>2,
        k=0;
    end
    if k==0,
        Upred(j,1)=U(3*Hu-2,1);
        Ud(2*Hu+i)=Ud(2*Hu-1);
        Ud(2*Hu+i+1)=0;
        i=i+2;
    else
        Upred(j,1)=0;        
    end

    k=k+1;
end

% Nd=1;
% Yd=-0.2;
% ku=5;
% step=0.1;
% ts=0.4;

Xki=zeros(Hp*2,1);
yk=xk(1);
ysk=xk(2);
psik=xk(3);
usk=xk(4);
vk=xk(5);
vsk=xk(6);
rk=xk(7);
j=1;
k=1;
l=1;


for i=s:s:Hp*ts,%integrer med sm steg, sample ved Ts sett inn uk ved Ts
    l=l+1;
    uc=Ud(k);
    duc=Ud(k+1);
    vskc=current*currk(2)*sin(currk(1)-psik);
    %%%% dynamics %%%%
    denum=Upred(j)^2+ysk^2;
    a1=(usk+uc)*sin(psik)+vsk*cos(psik);%ysprikk
    a3=(Upsilon*usk+Theta*uc+M)*rk+(Lambda*usk+Xi*uc)*vsk+N*(vsk-vskc);%vskprikk
    a2=rk*cos(psik)*(usk+uc)-rk*sin(psik)*vsk+a3*cos(psik)+(duc-ku*usk)*sin(psik);%ystrek dobbel prikk
    a4=2*(Upred(j)*Upred(j+1)+ysk*a1)*(Upred(j)*a1-ysk*Upred(j+1))/...
        denum^2+(ysk*Upred(j+2)-Upred(j)*a2)/denum;%rdprikk   
    rd=(-Upred(j)*a1+ysk*Upred(j+1))/denum;%delta time varying
    z1=psik+atan2(ysk,Upred(j));%avvik psi
    z2=rk-rd;%avvik r
    
    %%%% end dyn %%%%
    
    %%%% integrate %%%%
 %   vsk1=vsk+s*a3;
    rk1=rk+s*(a4-k1*z2-k0*z1);  
    vk1=vk+s*(a3-eps*(a4-k1*z2-k0*z1));%dotv=dotvs-eps*dotr
    vsk1=vk1+eps*rk1;
    usk1=usk+s*(-ku*usk);
    % according to fossen eta(k+1)=
    % eta(k)+s(R(eta(k))nu(k+1))
    yk1=yk+s*((usk1+uc)*sin(psik)+vk1*cos(psik));
%    ysk1=ysk+s*((usk1+uc)*sin(psik)+vsk1*cos(psik));
    psik1=psik+s*rk1;
    ysk1=yk1+eps*sin(psik1);
    
    %%%% end int %%%%
    
    %% sample to form Xpred at Ts %%%
    %% evaluate the input vector at each time k=n*Ts
    
    if l==floor(ts/s)+1,
        l=1;
        j=j+3;
        k=k+2;
    end
    if l==1,
        %endring lagt til dyk, byttet vk1 med dyk
        dyk=(usk1+uc)*sin(psik)+vk1*cos(psik);%yprikk
        Xki(2*(j-1)/3-1:1:2*(j-1)/3,1)=[yk1; dyk]; %sjekk om dette funker!!!!!
%         Xki(3*(j-1)/3-2:1:3*(j-1)/3,1)=[yk1; dyk;psik1];
    end

    %%%% step to time k+1 %%%%    
    yk=yk1;
    ysk=ysk1;
    psik=psik1;
    usk=usk1;
    vk=vk1;
    vsk=vsk1;
    rk=rk1;
    
    %%% end step %%%%
end

%%%%%%  end prediction  %%%%%%%